--- lambdabot-4.2.2.1-orig/Plugin/Unlambda.hs	2009-01-18 16:01:15.000000000 +1100
+++ lambdabot-4.2.2.1/Plugin/Unlambda.hs	2011-01-04 11:15:57.503543429 +1100
@@ -17,10 +17,11 @@
     process _ _ to _ s = ios80 to (unlambda s)
 
 binary :: String
-binary = "./unlambda"
+binary = "unlambda"
 
 unlambda :: String -> IO String
-unlambda src = run binary src (unlines . take 6 . map (' ':) . lines . cleanit)
+unlambda src = run binary src scrub
+  where scrub = unlines . take 6 . map (' ':) . lines . cleanit
 
 cleanit :: String -> String
 cleanit s | terminated `matches'` s = "Terminated\n"
--- lambdabot-4.2.2.1-orig/State/L.hs	2009-01-18 16:01:15.000000000 +1100
+++ lambdabot-4.2.2.1/State/L.hs	2011-01-05 00:40:56.536399314 +1100
@@ -1,19 +1,22 @@
+{-# LANGUAGE NoMonomorphismRestriction, StandaloneDeriving, UndecidableInstances #-}
+{-# LANGUAGE PackageImports #-}
 module L where
+import Prelude hiding ((.),(++),flip)
 import Control.Applicative
-import Control.Arrow hiding (pure)
+import Control.Arrow
 import Control.Arrow.Operations
 import Control.Monad
-import Control.Monad.Cont
-import Control.Monad.Error
+import "mtl" Control.Monad.Cont
+import "mtl" Control.Monad.Error
 import Control.Monad.Fix
-import Control.Monad.Identity
+import "mtl" Control.Monad.Identity
 import Control.Monad.Instances
 import Control.Monad.Logic
-import Control.Monad.RWS
-import Control.Monad.Reader
+import "mtl" Control.Monad.RWS
+import "mtl" Control.Monad.Reader
 import Control.Monad.ST (ST, runST, fixST)
-import Control.Monad.State
-import Control.Monad.Writer
+import "mtl" Control.Monad.State
+import "mtl" Control.Monad.Writer
 import Control.Parallel
 import Control.Parallel.Strategies
 import Data.Array
@@ -25,7 +28,7 @@
 import Data.Either
 import Data.Eq
 import Data.Fixed
-import Data.Function hiding ((.))
+import Data.Function hiding ((.),flip)
 import Data.Generics hiding (GT)
 import Data.Graph
 import Data.Int
@@ -36,9 +39,7 @@
 import Data.Number.BigFloat
 import Data.Number.CReal
 import Data.Number.Dif
-import Data.Number.Fixed
 import Data.Number.Interval
-import Data.Number.Natural
 import Data.Number.Symbolic
 import Data.Ord
 import Data.Ratio
@@ -50,7 +51,6 @@
 import Numeric
 import ShowQ
 import System.Random
-import Test.QuickCheck
 import Text.PrettyPrint.HughesPJ hiding (empty)
 import Text.Printf
 import Text.Regex.Posix
@@ -65,17 +65,99 @@
 import qualified Data.IntMap as IM
 import qualified Data.IntSet as IS
 import qualified Data.Map as M
-import qualified Data.Sequence
+import qualified Data.Sequence as Seq
 import qualified Data.Set as S
 import qualified Data.Traversable
+import qualified Data.MemoCombinators as Memo
+import ShowIO
 
 import SimpleReflect hiding (var)
 import Math.OEIS
+import Control.Monad.Random
+
+import Data.VectorSpace hiding (Sum, getSum)
+import Data.NumInstances
+import Data.LinearMap
+
+import qualified Test.IOSpec as IOSpec
+
+import Data.Fixed
+
+(.) :: (Functor f) => (a -> b) -> f a -> f b
+(.) = fmap
+infixr 9 .
+
+flip :: Functor f => f (a -> b) -> a -> f b
+flip f x = fmap ($ x) f
+
+(++) :: (Monoid m) => m -> m -> m
+(++) = mappend
+infixr 5 ++
+
+asTypeIn :: a -> (a -> b) -> a
+a `asTypeIn` f = a where _ = f a
+infixl 0 `asTypeIn`
+
+f `asAppliedTo` x = f `asTypeIn` \f -> f x
+infixl 0 `asAppliedTo`
 
 describeSequence = fmap description . lookupSequence
 
-newtype Mu f = In { out :: f (Mu f) }
+newtype Mu f = In (f (Mu f))
+out (In x) = x
+deriving instance Show (f (Mu f)) => Show (Mu f)
 
 newtype Rec a = InR { outR :: Rec a -> a }
 
+data Bin a = Tip | Branch a (Bin a) (Bin a)
+  deriving (Eq, Ord, Show, Read)
+-- Fun Stuff
+
+cake = ["One 18.25 ounce package chocolate cake mix.",
+        "One can prepared coconut pecan frosting.",
+        "Three slash four cup vegetable oil.",
+        "Four large eggs.",
+        "One cup semi-sweet chocolate chips.",
+        "Three slash four cups butter or margarine.",
+        "One and two third cups granulated sugar.",
+        "Two cups all-purpose flour.",
+        "Don't forget garnishes such as:",
+        "Fish shaped crackers.",
+        "Fish shaped candies.",
+        "Fish shaped solid waste.",
+        "Fish shaped dirt.",
+        "Fish shaped ethylbenzene.",
+        "Pull and peel licorice.",
+        "Fish shaped organic compounds and sediment shaped sediment.",
+        "Candy coated peanut butter pieces. Shaped like fish.",
+        "One cup lemon juice.",
+        "Alpha resins.",
+        "Unsaturated polyester resin.",
+        "Fiberglass surface resins.",
+        "And volatile malted milk impoundments.",
+        "Nine large egg yolks.",
+        "Twelve medium geosynthetic membranes.",
+        "One cup granulated sugar.",
+        "An entry called 'how to kill someone with your bare hands.'",
+        "Two cups rhubarb, sliced.",
+        "Two slash three cups granulated rhubarb.",
+        "One tablespoon all-purpose rhubarb.",
+        "One teaspoon grated orange rhubarb.",
+        "Three tablespoons rhubarb, on fire.",
+        "One large rhubarb.",
+        "One cross borehole electro-magnetic imaging rhubarb.",
+        "Two tablespoons rhubarb juice.",
+        "Adjustable aluminum head positioner.",
+        "Slaughter electric needle injector.",
+        "Cordless electric needle injector.",
+        "Injector needle driver.",
+        "Injector needle gun.",
+        "Cranial caps.",
+        "And it contains proven preservatives, deep penetration agents, and gas and odor control chemicals.",
+        "That will deodorize and preserve putrid tissue."]
+
 {-# LINE 1 "<local>" #-}
+(****) = (\f n v -> (iterate f v) !! n)
+toChurch = ((appEndo . Data.Foldable.foldMap Endo) .) . replicate
+fromChuch f = f (+1) 0
+evalCont :: Cont o o -> o; evalCont = (`runCont` id)
--- lambdabot-4.2.2.1-orig/State/Pristine.hs	2009-01-18 16:01:16.000000000 +1100
+++ lambdabot-4.2.2.1/State/Pristine.hs	2011-01-04 11:15:57.512384424 +1100
@@ -1,6 +1,8 @@
+{-# LANGUAGE NoMonomorphismRestriction, StandaloneDeriving, UndecidableInstances #-}
 module L where
+import Prelude hiding ((.),(++),flip)
 import Control.Applicative
-import Control.Arrow hiding (pure)
+import Control.Arrow
 import Control.Arrow.Operations
 import Control.Monad
 import Control.Monad.Cont
@@ -25,7 +27,7 @@
 import Data.Either
 import Data.Eq
 import Data.Fixed
-import Data.Function hiding ((.))
+import Data.Function hiding ((.),flip)
 import Data.Generics hiding (GT)
 import Data.Graph
 import Data.Int
@@ -36,9 +38,7 @@
 import Data.Number.BigFloat
 import Data.Number.CReal
 import Data.Number.Dif
-import Data.Number.Fixed
 import Data.Number.Interval
-import Data.Number.Natural
 import Data.Number.Symbolic
 import Data.Ord
 import Data.Ratio
@@ -50,7 +50,6 @@
 import Numeric
 import ShowQ
 import System.Random
-import Test.QuickCheck
 import Text.PrettyPrint.HughesPJ hiding (empty)
 import Text.Printf
 import Text.Regex.Posix
@@ -65,17 +64,95 @@
 import qualified Data.IntMap as IM
 import qualified Data.IntSet as IS
 import qualified Data.Map as M
-import qualified Data.Sequence
+import qualified Data.Sequence as Seq
 import qualified Data.Set as S
 import qualified Data.Traversable
+import qualified Data.MemoCombinators as Memo
+import ShowIO
 
 import SimpleReflect hiding (var)
 import Math.OEIS
+import Control.Monad.Random
+
+import Data.VectorSpace hiding (Sum, getSum)
+import Data.NumInstances
+import Data.LinearMap
+
+import qualified Test.IOSpec as IOSpec
+
+import Data.Fixed
+
+(.) :: (Functor f) => (a -> b) -> f a -> f b
+(.) = fmap
+infixr 9 .
+
+flip :: Functor f => f (a -> b) -> a -> f b
+flip f x = fmap ($ x) f
+
+(++) :: (Monoid m) => m -> m -> m
+(++) = mappend
+infixr 5 ++
+
+asTypeIn :: a -> (a -> b) -> a
+a `asTypeIn` f = a where _ = f a
+infixl 0 `asTypeIn`
+
+f `asAppliedTo` x = f `asTypeIn` \f -> f x
+infixl 0 `asAppliedTo`
 
 describeSequence = fmap description . lookupSequence
 
-newtype Mu f = In { out :: f (Mu f) }
+newtype Mu f = In (f (Mu f))
+out (In x) = x
+deriving instance Show (f (Mu f)) => Show (Mu f)
 
 newtype Rec a = InR { outR :: Rec a -> a }
 
+data Bin a = Tip | Branch a (Bin a) (Bin a)
+  deriving (Eq, Ord, Show, Read)
+-- Fun Stuff
+
+cake = ["One 18.25 ounce package chocolate cake mix.",
+        "One can prepared coconut pecan frosting.",
+        "Three slash four cup vegetable oil.",
+        "Four large eggs.",
+        "One cup semi-sweet chocolate chips.",
+        "Three slash four cups butter or margarine.",
+        "One and two third cups granulated sugar.",
+        "Two cups all-purpose flour.",
+        "Don't forget garnishes such as:",
+        "Fish shaped crackers.",
+        "Fish shaped candies.",
+        "Fish shaped solid waste.",
+        "Fish shaped dirt.",
+        "Fish shaped ethylbenzene.",
+        "Pull and peel licorice.",
+        "Fish shaped organic compounds and sediment shaped sediment.",
+        "Candy coated peanut butter pieces. Shaped like fish.",
+        "One cup lemon juice.",
+        "Alpha resins.",
+        "Unsaturated polyester resin.",
+        "Fiberglass surface resins.",
+        "And volatile malted milk impoundments.",
+        "Nine large egg yolks.",
+        "Twelve medium geosynthetic membranes.",
+        "One cup granulated sugar.",
+        "An entry called 'how to kill someone with your bare hands.'",
+        "Two cups rhubarb, sliced.",
+        "Two slash three cups granulated rhubarb.",
+        "One tablespoon all-purpose rhubarb.",
+        "One teaspoon grated orange rhubarb.",
+        "Three tablespoons rhubarb, on fire.",
+        "One large rhubarb.",
+        "One cross borehole electro-magnetic imaging rhubarb.",
+        "Two tablespoons rhubarb juice.",
+        "Adjustable aluminum head positioner.",
+        "Slaughter electric needle injector.",
+        "Cordless electric needle injector.",
+        "Injector needle driver.",
+        "Injector needle gun.",
+        "Cranial caps.",
+        "And it contains proven preservatives, deep penetration agents, and gas and odor control chemicals.",
+        "That will deodorize and preserve putrid tissue."]
+
 {-# LINE 1 "<local>" #-}
Files lambdabot-4.2.2.1-orig/State/fact and lambdabot-4.2.2.1/State/fact differ
--- lambdabot-4.2.2.1-orig/State/fresh	2009-01-18 16:01:16.000000000 +1100
+++ lambdabot-4.2.2.1/State/fresh	2011-01-04 11:15:57.513384728 +1100
@@ -1 +1 @@
-0
\ No newline at end of file
+94
\ No newline at end of file
--- lambdabot-4.2.2.1-orig/State/imports.h	2009-01-18 16:01:17.000000000 +1100
+++ lambdabot-4.2.2.1/State/imports.h	2011-01-04 11:15:57.514383561 +1100
@@ -44,7 +44,6 @@
 import Data.Number.Fixed
 import Data.Number.Interval
 import Data.Number.BigFloat
-import Data.Number.Natural
 import Control.Monad
 import Control.Monad.Cont
 import Control.Monad.Identity
@@ -72,3 +71,9 @@
 
 import SimpleReflect hiding (var)
 import Math.OEIS
+
+import Data.VectorSpace
+import Data.NumInstances
+import Data.LinearMap
+
+import Data.Fixed
